# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from robotnik_msgs/OdomManualCalibrationStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class OdomManualCalibrationStatus(genpy.Message):
  _md5sum = "f77436bc07e4185538807c200cd1cc07"
  _type = "robotnik_msgs/OdomManualCalibrationStatus"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """geometry_msgs/Pose odom_increment             # odometry increment since last reset
geometry_msgs/Pose real_increment             # real increment since last reset

float32 linear_error            # linear error between odom and real since last reset
float32 angular_error           # angular error between odom and real since last reset

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['odom_increment','real_increment','linear_error','angular_error']
  _slot_types = ['geometry_msgs/Pose','geometry_msgs/Pose','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       odom_increment,real_increment,linear_error,angular_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(OdomManualCalibrationStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.odom_increment is None:
        self.odom_increment = geometry_msgs.msg.Pose()
      if self.real_increment is None:
        self.real_increment = geometry_msgs.msg.Pose()
      if self.linear_error is None:
        self.linear_error = 0.
      if self.angular_error is None:
        self.angular_error = 0.
    else:
      self.odom_increment = geometry_msgs.msg.Pose()
      self.real_increment = geometry_msgs.msg.Pose()
      self.linear_error = 0.
      self.angular_error = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_14d2f().pack(_x.odom_increment.position.x, _x.odom_increment.position.y, _x.odom_increment.position.z, _x.odom_increment.orientation.x, _x.odom_increment.orientation.y, _x.odom_increment.orientation.z, _x.odom_increment.orientation.w, _x.real_increment.position.x, _x.real_increment.position.y, _x.real_increment.position.z, _x.real_increment.orientation.x, _x.real_increment.orientation.y, _x.real_increment.orientation.z, _x.real_increment.orientation.w, _x.linear_error, _x.angular_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.odom_increment is None:
        self.odom_increment = geometry_msgs.msg.Pose()
      if self.real_increment is None:
        self.real_increment = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 120
      (_x.odom_increment.position.x, _x.odom_increment.position.y, _x.odom_increment.position.z, _x.odom_increment.orientation.x, _x.odom_increment.orientation.y, _x.odom_increment.orientation.z, _x.odom_increment.orientation.w, _x.real_increment.position.x, _x.real_increment.position.y, _x.real_increment.position.z, _x.real_increment.orientation.x, _x.real_increment.orientation.y, _x.real_increment.orientation.z, _x.real_increment.orientation.w, _x.linear_error, _x.angular_error,) = _get_struct_14d2f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_14d2f().pack(_x.odom_increment.position.x, _x.odom_increment.position.y, _x.odom_increment.position.z, _x.odom_increment.orientation.x, _x.odom_increment.orientation.y, _x.odom_increment.orientation.z, _x.odom_increment.orientation.w, _x.real_increment.position.x, _x.real_increment.position.y, _x.real_increment.position.z, _x.real_increment.orientation.x, _x.real_increment.orientation.y, _x.real_increment.orientation.z, _x.real_increment.orientation.w, _x.linear_error, _x.angular_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.odom_increment is None:
        self.odom_increment = geometry_msgs.msg.Pose()
      if self.real_increment is None:
        self.real_increment = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 120
      (_x.odom_increment.position.x, _x.odom_increment.position.y, _x.odom_increment.position.z, _x.odom_increment.orientation.x, _x.odom_increment.orientation.y, _x.odom_increment.orientation.z, _x.odom_increment.orientation.w, _x.real_increment.position.x, _x.real_increment.position.y, _x.real_increment.position.z, _x.real_increment.orientation.x, _x.real_increment.orientation.y, _x.real_increment.orientation.z, _x.real_increment.orientation.w, _x.linear_error, _x.angular_error,) = _get_struct_14d2f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_14d2f = None
def _get_struct_14d2f():
    global _struct_14d2f
    if _struct_14d2f is None:
        _struct_14d2f = struct.Struct("<14d2f")
    return _struct_14d2f
